package transportgrpc

import (
	"git.perx.ru/perxis/perxis-go/pkg/collaborators"
	"git.perx.ru/perxis/perxis-go/pkg/collaborators/transport"
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	pb "git.perx.ru/perxis/perxis-go/proto/collaborators"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc collaborators.Collaborators, opts ...grpckit.ServerOption) pb.CollaboratorsServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		GetEndpoint:               grpcerr.ServerMiddleware(eps.GetEndpoint),
		ListSpacesEndpoint:        grpcerr.ServerMiddleware(eps.ListSpacesEndpoint),
		ListCollaboratorsEndpoint: grpcerr.ServerMiddleware(eps.ListCollaboratorsEndpoint),
		RemoveEndpoint:            grpcerr.ServerMiddleware(eps.RemoveEndpoint),
		SetEndpoint:               grpcerr.ServerMiddleware(eps.SetEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
