// Code generated by gowrap. DO NOT EDIT.
// template: ..\..\..\assets\templates\middleware\telemetry
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/files -i Files -t ..\..\..\assets\templates\middleware\telemetry -o telemetry_middleware.go -l ""

// source template: https://github.com/hexdigest/gowrap/blob/master/templates/opentelemetry

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/files"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

// telemetryMiddleware implements files.Files interface instrumented with opentracing spans
type telemetryMiddleware struct {
	files.Files
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base files.Files, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		Files:          base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// AbortUpload implements files.Files
func (_d telemetryMiddleware) AbortUpload(ctx context.Context, upload *files.MultipartUpload) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Files"),
		attribute.String("method", "AbortUpload"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Files.AbortUpload")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":    ctx,
				"upload": upload}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Files.AbortUpload(ctx, upload)
}

// CompleteUpload implements files.Files
func (_d telemetryMiddleware) CompleteUpload(ctx context.Context, upload *files.MultipartUpload) (u *files.MultipartUpload, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Files"),
		attribute.String("method", "CompleteUpload"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Files.CompleteUpload")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":    ctx,
				"upload": upload}, map[string]interface{}{
				"u":   u,
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Files.CompleteUpload(ctx, upload)
}

// DeleteFile implements files.Files
func (_d telemetryMiddleware) DeleteFile(ctx context.Context, file *files.File) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Files"),
		attribute.String("method", "DeleteFile"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Files.DeleteFile")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":  ctx,
				"file": file}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Files.DeleteFile(ctx, file)
}

// GetFile implements files.Files
func (_d telemetryMiddleware) GetFile(ctx context.Context, file *files.File) (f *files.File, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Files"),
		attribute.String("method", "GetFile"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Files.GetFile")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":  ctx,
				"file": file}, map[string]interface{}{
				"f":   f,
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Files.GetFile(ctx, file)
}

// MoveUpload implements files.Files
func (_d telemetryMiddleware) MoveUpload(ctx context.Context, upload *files.MultipartUpload) (file *files.File, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Files"),
		attribute.String("method", "MoveUpload"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Files.MoveUpload")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":    ctx,
				"upload": upload}, map[string]interface{}{
				"file": file,
				"err":  err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Files.MoveUpload(ctx, upload)
}

// StartUpload implements files.Files
func (_d telemetryMiddleware) StartUpload(ctx context.Context, upload *files.MultipartUpload) (u *files.MultipartUpload, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Files"),
		attribute.String("method", "StartUpload"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Files.StartUpload")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":    ctx,
				"upload": upload}, map[string]interface{}{
				"u":   u,
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Files.StartUpload(ctx, upload)
}

// Upload implements files.Files
func (_d telemetryMiddleware) Upload(ctx context.Context, file *files.File) (u *files.Upload, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Files"),
		attribute.String("method", "Upload"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Files.Upload")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":  ctx,
				"file": file}, map[string]interface{}{
				"u":   u,
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Files.Upload(ctx, file)
}
